/*
 * Copyright (c) 2005, Your Corporation. All Rights Reserved.
 */

package bookExamples.ch18Swing;

import javax.swing.*;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableColumn;
import javax.swing.table.JTableHeader;
import javax.swing.table.AbstractTableModel;
import javax.swing.border.LineBorder;
import java.awt.*;
import java.text.SimpleDateFormat;
import java.util.Vector;
import java.util.Date;

/**
 * User: lyon
 * Date: Dec 29, 2005
 * Time: 4:24:00 AM
 * Copyright DocJava, Inc. 2005.
 */
public class StocksTable extends JFrame {

    protected JTable m_table;

    protected StockTableData m_data= new StockTableData();
    protected JLabel m_title;

    public StocksTable() {
        super("Stocks Table");
        setSize(600, 300);

        UIManager.put("Table.focusCellHighlightBorder",
                new LineBorder(Color.black, 0));



        m_title = new JLabel(m_data.getTitle(), SwingConstants.CENTER);
        m_title.setFont(new Font("Helvetica", Font.PLAIN, 24));
        getContentPane().add(m_title, BorderLayout.NORTH);

        m_table = new JTable();
        m_table.setAutoCreateColumnsFromModel(false);
        m_table.setModel(m_data);

        for (int k = 0; k < m_data.getColumnCount(); k++) {
            DefaultTableCellRenderer renderer = new
                    DefaultTableCellRenderer();
            renderer.setHorizontalAlignment(
                    StockTableData.m_columns[k].alignment);
            TableColumn column = new TableColumn(k,
                    StockTableData.m_columns[k].width, renderer, null);
            m_table.addColumn(column);
        }

        JTableHeader header = m_table.getTableHeader();
        header.setUpdateTableInRealTime(false);

        JScrollPane ps = new JScrollPane();
        ps.getViewport().setBackground(m_table.getBackground());
        ps.getViewport().add(m_table);
        getContentPane().add(ps, BorderLayout.CENTER);
    }

    public static void main(String argv[]) {
        StocksTable frame = new StocksTable();
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setVisible(true);
    }
}

